#!/usr/bin/env -S nim c -r
import os
import osproc
import sequtils
import strutils
import strformat
import std/[times, monotimes]

proc run(n, k: string) =
  let n = n.absolutePath
  echo execProcess &"../certifaigerWL {n} {k}"
  let t = getMonoTime()
  let r = execProcess &"../avr.sh {n}"
  echo "t_model: " & (inMilliseconds(getMonoTime()-t).float/1000.0).formatFloat(ffDecimal, 3)
  assert "inductive at" in r

for i in "benchmarks.csv".readfile.strip.splitlines.mapit it.split(","):
  run(i[0], i[1])

for b in 33..1031:
  let n = &"counter_{b}.btor2"
  discard execProcess &"./counter 500 32 {b} > {n}"
  run(n, $(b-31))
  discard execProcess &"rm {n}"
